#define WIN32_LEAN_AND_MEAN
#include <windows.h>

#include "../../../dtr.hpp"

static BYTE *hr_d_output;
static BYTE *hr_d_input;
static BYTE  hr_d_tagbyte;/*  .*/
static BYTE __index = 7;

static BYTE hr_d_getbit(void)
{
    BYTE bit[] = { 0x80, 0x40, 0x20, 0x10, 0x08, 0x04, 0x02, 0x01 };

    __index = (__index + 1) % 8;
    if(__index == 0) hr_d_tagbyte = *hr_d_input++;

    return (hr_d_tagbyte & bit[__index]) == 0 ? 0 : 1;
}

static WORD hr_d_getlen(void)
{
    WORD tmp, result = 1;
    do
    {
        tmp = (hr_d_getbit() << 1) + hr_d_getbit();
        result += tmp;
    } while(tmp == 0x03 && result != 0x10);

    return(result);
}

static WORD hr_d_getdist(void)
{
    WORD result;volatile WORD tmp;

    if(hr_d_getbit())
    {
        result = 0xff00 + *hr_d_input++;
    }
    else
    {
        result = 0xffff;
        tmp    = (hr_d_getbit() << 1) + hr_d_getbit() + 0xffff-3;

        for(; tmp; tmp++) result = (result << 1) + hr_d_getbit() - 1;
        if(result == 0xffff - 30)  result = *hr_d_input++;
        result = (result << 8) + *hr_d_input++;
    }
    return (result);
}

static void dehrust(BYTE* source, BYTE* destination)
{
    __index = 7;
    WORD  len;
    short offs;

    hr_d_input   = source + 6;
    hr_d_output  = destination;

    *hr_d_output++ = *hr_d_input++;

    while(true)
    {
        if(!hr_d_getbit())
        {
            len = hr_d_getlen();
            offs = 0xffff;

            if(len == 4)
            {
                if(hr_d_getbit())
                {
                    len = *hr_d_input++;

                    if(len == 0)
                        break;
                    else
                        if(len < 16) len = (len << 8) + *hr_d_input++;

                        offs = hr_d_getdist();

                        for(; len; len--) *hr_d_output = *(hr_d_output++ + offs);
                }
                else
                {
                    len = 0;
                    for(int i = 4; i; i--) len = (len << 1) + hr_d_getbit();
                    len += 6;
                    len <<= 1;
                    for(; len; len--) *hr_d_output++ = *hr_d_input++;
                }
            }
            else
            {
                if(len > 4) len--;
                if(len == 1)
                {
                    for(int i = 3; i; i--) offs = (offs << 1) + hr_d_getbit();
                }
                else
                {
                    if(len == 2)
                        offs = 0xff00 + *hr_d_input++;
                    else
                        offs = hr_d_getdist();
                }
                for(; len; len--) *hr_d_output = *(hr_d_output++ + offs);
            }
        }
        else
        {
            *hr_d_output++ = *hr_d_input++;
        }
    }

    for(int i = 0; i < 6; i++) *hr_d_output++ = source[i];
}

bool WINAPI extract(HoHdr *hdr, const BYTE *source, DWORD, BYTE *unpackBuffer, DWORD *noUnpackedBytes, DWORD)
{
    *noUnpackedBytes = *(WORD*)(source + 6);

    if(source[5] & 1)
        CopyMemory(unpackBuffer, source + 0x0B + source[10], *noUnpackedBytes);
    else
        dehrust((BYTE*)source + 0x0B + source[10], unpackBuffer);

    return true;
}

bool WINAPI detect(DetectorResult &result, const wchar_t*, const HoHdr*, const BYTE *data, int file_size)
{
    if(data[0] != 'H' || data[1] != 'r' || data[2] != 's' || data[3] != 't' || data[4] != '2' || (data[5] & 0xDE) != 0x06) return false;

    WORD size        = *(WORD*)(data + 6);
    WORD packed_size = *(WORD*)(data + 8);

    if(packed_size > size || packed_size > file_size) return false;

    result.action = do_extract;
    lstrcpyW(result.title, L"[hrust 2.2+]");

    return true;
}
